<?php

// Load necessary libraries
require_once __DIR__ . '/src/dna.php';

$username = 'aman.k@inframail.io';
$password = 'KfutLxmdopbBxZ';
$dna = new \DomainNameApi\DomainNameAPI_PHPLibrary($username, $password);


// Check if POST request is received
if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    // Assuming JSON input like {"domainName":"example.com","nameServer":"ns1.example.com","ipAddress":"10.0.0.1"}
    $input = json_decode(file_get_contents('php://input'), true);

    // Validate input (add more validation as needed)
    if (isset($input['domainName']) && isset($input['nameServer']) && isset($input['ipAddress'])) {
        $domainName = $input['domainName'];
        $nameServer = $input['nameServer'];
        $ipAddress = $input['ipAddress'];

        try {
            $result = $dna->AddChildNameServer($domainName, $nameServer, $ipAddress);

            echo json_encode($result);
            exit;
        } catch (Exception $e) {
            // Handle exception
            http_response_code(500); // Internal Server Error
            echo json_encode(array("error" => $e->getMessage()));
            exit;
        }
    } else {
        // Invalid request format
        http_response_code(400);
        echo json_encode(array("error" => "Invalid request format"));
        exit;
    }
} else if ($_SERVER['REQUEST_METHOD'] === 'PUT') {
    // Assuming JSON input like {"domainName":"example.com","nameServer":"ns1.example.com","ipAddress":"10.0.0.1"}
    $input = json_decode(file_get_contents('php://input'), true);

    // Validate input (add more validation as needed)
    if (isset($input['domainName']) && isset($input['nameServer']) && isset($input['ipAddress'])) {
        $domainName = $input['domainName'];
        $nameServer = $input['nameServer'];
        $ipAddress = $input['ipAddress'];

        try {
            // Call the function to add the name server
            $result = $dna->ModifyChildNameServer($domainName, $nameServer, $ipAddress);

            // Return JSON response
            echo json_encode($result);
            exit;
        } catch (Exception $e) {
            // Handle exception
            http_response_code(500); // Internal Server Error
            echo json_encode(array("error" => $e->getMessage()));
            exit;
        }
    } else {
        // Invalid request format
        http_response_code(400);
        echo json_encode(array("error" => "Invalid request format"));
        exit;
    }
} else if ($_SERVER['REQUEST_METHOD'] === 'DELETE') {
    // Assuming JSON input like {"domainName":"example.com","nameServer":"ns1.example.com"}
    $input = json_decode(file_get_contents('php://input'), true);

    // Validate input (add more validation as needed)
    if (isset($input['domainName']) && isset($input['nameServer'])) {
        $domainName = $input['domainName'];
        $nameServer = $input['nameServer'];
        try {
            // Call the function to add the name server
            $result = $dna->DeleteChildNameServer($domainName, $nameServer);

            // Return JSON response
            echo json_encode($result);
            exit;
        } catch (Exception $e) {
            // Handle exception
            http_response_code(500); // Internal Server Error
            echo json_encode(array("error" => $e->getMessage()));
            exit;
        }
    } else {
        // Invalid request format
        http_response_code(400);
        echo json_encode(array("error" => "Invalid request format"));
        exit;
    }
} else {
    // Method not allowed
    http_response_code(405);
    echo json_encode(array("error" => "Method not allowed"));
    exit;
}